<?php 
/**
 * Plugin Name: Profile Avatar (Matomo Plugin)
 * Plugin URI: http://plugins.matomo.org/ProfileAvatar
 * Description: Show a random avatar on the Visitor Profile
 * Author: Lukas Winkler
 * Author URI: https://lw1.at
 * Version: 0.2.0
 */
?><?php

namespace Piwik\Plugins\ProfileAvatar;

use Piwik\DataTable\Row;
use Piwik\Plugin;

 
if (defined( 'ABSPATH')
&& function_exists('add_action')) {
    $path = '/matomo/app/core/Plugin.php';
    if (defined('WP_PLUGIN_DIR') && WP_PLUGIN_DIR && file_exists(WP_PLUGIN_DIR . $path)) {
        require_once WP_PLUGIN_DIR . $path;
    } elseif (defined('WPMU_PLUGIN_DIR') && WPMU_PLUGIN_DIR && file_exists(WPMU_PLUGIN_DIR . $path)) {
        require_once WPMU_PLUGIN_DIR . $path;
    } else {
        return;
    }
    add_action('plugins_loaded', function () {
        if (function_exists('matomo_add_plugin')) {
            matomo_add_plugin(__DIR__, __FILE__, true);
        }
    });
}

class ProfileAvatar extends Plugin
{
    public function registerEvents()
    {
        return array(
            'Live.renderVisitorDetails' => 'addImageToTemplate',
        );
    }

    public function addImageToTemplate(string &$outString, Row $visit)
    {
        $settings = new UserSettings();
        if (!$settings->showInVisitorLog->getValue()) {
            return;
        }
        $visitorID = $visit->getColumn("visitorId");
        $hash = hash("sha256", $visitorID);

        $outString .= "<img width='32' height='32' alt='user profile' src='?module=ProfileAvatar&action=getProfileAvatar&hash=$hash' aria-hidden='true'>";
    }
}
